<?PHP
function superuserlisting_getmoduleinfo() {
	$info = array(
		"name"=>"Superuser - List",
		"version"=>"1.0",
		"author"=>"`2R`@o`ghe`2n `Qvon `2Fa`@lk`genbr`@uch`&",
		"category"=>"Administrative",
		"download"=>"http://www.lotgd.de/downloads/superuserlisting.zip",
        "description"=>"Lists all Users with Superuser-Flag in the Game",
	);
	return $info;
}

function superuserlisting_install(){
	module_addhook("modifyuserview");
	module_addhook("superuser");
	return true;
}

function superuserlisting_uninstall(){
	return true;
}

function superuserlisting_dohook($hookname,$args){
	global $session;
	switch ($hookname) {
		case 'modifyuserview':
		case 'superuser':
			if ($session['user']['superuser'] & SU_EDIT_USERS) {
				addnav("Mechanics");
				addnav("List Superusers","runmodule.php?module=superuserlisting");
			}
	}
	return $args;
}

function sortByOneKey(array $array, $key, $asc = true) {
     $result = array();
         
     $values = array();
     foreach ($array as $id => $value) {
         $values[$id] = isset($value[$key]) ? $value[$key] : '';
     }
         
     if ($asc) {
         asort($values);
     }
     else {
         arsort($values);
     }
         
     foreach ($values as $key => $value) {
         $result[$key] = $array[$key];
     }
         
     return $result;
 }

function superuserlisting_run() {
	global $session;
	page_header("List of Superusers");
	require_once('lib/superusernav.php');
	superusernav();
	addnav("Refresh","runmodule.php?module=superuserlisting");
	
	output('`b`cListe der Superuser auf diesem System`c`b`n');
	$sql="SELECT acctid, name, superuser, laston FROM ". db_prefix("accounts") . " WHERE superuser>0 ORDER BY acctid ASC";
	$result=db_query($sql);
	
	output("Sortierung nach:`n");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=1'>1...Megauser</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=2'>2...Begleiter bearbeiten</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=3'>3...Monster bearbeiten</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=4'>4...Petitionen bearbeiten</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=5'>5...Chats bearbeiten</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=6'>6...Spenden</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=7'>7...Spieler ndern</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=8'>8...Spieleinstellungen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=9'>9...Unbegrenzte Spieltage</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=10'>10..Waffen / Rstungen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=11'>11..Zahlungen sehen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=12'>12..Entwicklerkrfte</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=13'>13..Motd erstellen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=14'>14..Debug anzeigen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=15'>15..Clans ndern</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=16'>16..Rtsel ndern</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=17'>17..Module verwalten</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=18'>18..Chats berwachen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=19'>19..bersetzer aktiv</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=20'>20..SQL ausfhren</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=21'>21..Quelltext ansehen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=22'>22..Lschschutz</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=23'>23..Items ndern</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=24'>24..Grottenzugang</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=25'>25..Keine Taubenwarnung</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=26'>26..PHP Fehler sehen</a><br>");
	rawoutput("<a href='runmodule.php?module=superuserlisting&sort=27'>27..Gamemaster</a><br>");
	
	for ($i=1;$i<=27;$i++) addnav("","runmodule.php?module=superuserlisting&sort=" . $i);
	
	$sulist=array();
	
	while ($row=db_fetch_assoc($result)) {
		$sulist[$row['name']]=array(
			0=>$row['acctid'],
			1=>($row['superuser'] & SU_MEGAUSER?"x":""),
			2=>($row['superuser'] & SU_EDIT_MOUNTS?"x":""),
			3=>($row['superuser'] & SU_EDIT_CREATURES?"x":""),
			4=>($row['superuser'] & SU_EDIT_PETITIONS?"x":""),
			5=>($row['superuser'] & SU_EDIT_COMMENTS?"x":""),
			6=>($row['superuser'] & SU_EDIT_DONATIONS?"x":""),
			7=>($row['superuser'] & SU_EDIT_USERS?"x":""),
			8=>($row['superuser'] & SU_EDIT_CONFIG?"x":""),
			9=>($row['superuser'] & SU_INFINITE_DAYS?"x":""),
			10=>($row['superuser'] & SU_EDIT_EQUIPMENT?"x":""),
			11=>($row['superuser'] & SU_EDIT_PAYLOG?"x":""),
			12=>($row['superuser'] & SU_DEVELOPER?"x":""),
			13=>($row['superuser'] & SU_POST_MOTD?"x":""),
			14=>($row['superuser'] & SU_DEBUG_OUTPUT?"x":""),
			15=>($row['superuser'] & SU_MODERATE_CLANS?"x":""),
			16=>($row['superuser'] & SU_EDIT_RIDDLES?"x":""),
			17=>($row['superuser'] & SU_MANAGE_MODULES?"x":""),
			18=>($row['superuser'] & SU_AUDIT_MODERATION?"x":""),
			19=>($row['superuser'] & SU_IS_TRANSLATOR?"x":""),
			20=>($row['superuser'] & SU_RAW_SQL?"x":""),
			21=>($row['superuser'] & SU_VIEW_SOURCE?"x":""),
			22=>($row['superuser'] & SU_NEVER_EXPIRE?"x":""),
			23=>($row['superuser'] & SU_EDIT_ITEMS?"x":""),
			24=>($row['superuser'] & SU_GIVE_GROTTO?"x":""),
			25=>($row['superuser'] & SU_OVERRIDE_YOM_WARNING?"x":""),
			26=>($row['superuser'] & SU_SHOW_PHPNOTICE?"x":""),
			27=>($row['superuser'] & SU_IS_GAMEMASTER?"x":"")
		);
	}
	$sort=(int)httpget('sort');
	if ($sort!=0) $sulist=sortByOneKey($sulist,$sort,false);
	
	
	$r=0;
	rawoutput("<table border=1 width=90%>");
	rawoutput("<tr class='trhead'><td>Name</td>");
	for ($i=1;$i<=27;$i++) rawoutput("<td>" . $i . "</td>");
	rawoutput("</tr>");
	
	foreach ($sulist as $key => $val) {
		$r++;
		addnav("","user.php?op=edit&userid=" . $val[0]);
		rawoutput("<tr class=" . ($r%2?'trlight':'trdark') . "><td><a href='user.php?op=edit&userid=" . $val[0] . "'>");
		output_notl($key);
		rawoutput("</a></td>");
		for ($i=1;$i<=27;$i++) {
			rawoutput("<td>");
			output_notl($val[$i]);
			rawoutput("</td>");
		}
		rawoutput("</tr>");
	}
	rawoutput("</table>");
	page_footer();
}
?>